#!/bin/bash
#
#    Copyright (c) 2013 Sebastian Dufner
#    This file is part of Generic AutoEx.
#
#    Generic AutoEx is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Generic AutoEx is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Generic AutoEx.  If not, see <http://www.gnu.org/licenses/>.

STATE_START=0
STATE_EX=1
STATE_NEWINDENT=3
STATE_DASHLIST=4
STATE_DASHLIST_NEWINDENT=5
STATE_END=2

indent=0
instructions="$1"
ex="$2"
state=$STATE_START

indent_string ()
{
    if [ $state = $STATE_NEWINDENT ] || [ $state = $STATE_DASHLIST_NEWINDENT ]
    then
        for (( i=1; i <= ($indent - 1); i++ ))
        do
            echo -n "    "
        done

        echo "  ‣ $1"
    else
        for (( i=1; i <= $indent; i++ ))
        do
            echo -n "    "
        done

        echo "$1"
    fi
}

process_line ()
{
    if [ $state = $STATE_START ]
    then
        if echo "$1" | grep -i "^\* =$ex=" &> /dev/null
        then
            state=$STATE_EX
        fi
    elif [ $state = $STATE_EX ] || [ $state = $STATE_DASHLIST ]
    then
        if echo "$1" | grep "^\* " &> /dev/null
        then
            state=$STATE_END
        else
            if echo "$1" | grep -i "^\*\* " &> /dev/null
            then
                indent=1
                state=$STATE_NEWINDENT
            elif echo "$1" | grep -i "^\*\*\* " &> /dev/null
            then
                indent=2
                state=$STATE_NEWINDENT
            elif echo "$1" | grep -i "^\*\*\*\* " &> /dev/null
            then
                indent=3
                state=$STATE_NEWINDENT
            elif echo "$1" | grep -i "^\*\*\*\*\* " &> /dev/null
            then
                indent=4
                state=$STATE_NEWINDENT
            elif echo "$1" | grep -i "^\*\*\*\*\*\* " &> /dev/null
            then
                indent=5
                state=$STATE_NEWINDENT
            elif echo "$1" | grep -i "^-" &> /dev/null
            then
                if ! [ $state = $STATE_DASHLIST ]
                then
                    indent=$(( $indent + 1 ))
                fi

                state=$STATE_DASHLIST_NEWINDENT
            fi

            indent_string "$(echo "$1" | sed -r 's/^(\*|-)*//;s/^ *//;s/=([^=]*)=/'`echo -en "\e[2m"`'\1'`printf "\033[0m"`'/g;'" s/,,([^']*)''/`echo -en "\e[3m"`\1`echo -en "\e[0m"`/g")"

            if [ $state = $STATE_DASHLIST_NEWINDENT ]
            then
                state=$STATE_DASHLIST
            else
                state=$STATE_EX
            fi
        fi
    fi
}

while read -r line
do
    process_line "$line"
done < "$instructions"
